from sys import argv
from moteur_chainage_arriere.connaissance import BaseConnaissances
from moteur_chainage_arriere.chainage_arriere import ChainageArriere
from moteur_avec_variables.regle_avec_variables import RegleAvecVariables
from moteur_avec_variables.unificateur import Unificateur

faits = [
    ('a-des-poils', 'blaireau'),
    ('a-des-bébés-formes', 'blaireau'),
    ('température-stable', 'blaireau'),
    ('a-des-poils', 'écureuil'),
    ('a-des-bébés-formes', 'écureuil'),
    ('température-stable', 'écureuil'),
    ('chimpanzé', 'cheetah'),
    ('gorille', 'bozo'),
    ('singe', 'babouin'),
    ('singe', 'paresseux'),
    ('chien', 'bill'),
    ('loup', 'loup-1'),
    ('lycaon', 'lycaon-1'),
    ('chat', 'mistigri'),
    ('lion', 'minet'),
    ('tigre-du-bengale', 'tigre-du-bengale-1'),
    ('a-des-poils', 'kangourou'),
    ('a-des-bébés-foetaux', 'kangourou'),
    ('température-stable', 'kangourou'),
    ('pond-des-oeufs', 'ornythorinque'),
    ('pond-des-oeufs', 'nouveau-spécimen'),
    ('a-des-poils', 'ornythorinque'),
    ('température-stable', 'nouveau-spécimen'),
    ('température-stable', 'ornythorinque'),
]

regles = [
    [[('placentaire', '?x')], ('mammifère', '?x')],
    [[('marsupial', '?x')], ('mammifère', '?x')],
    [[('monotrème', '?x')], ('mammifère', '?x')],
    [[('placentaire-1', '?x')], ('placentaire', '?x')],
    [[('genre-placentaire', '?x')], ('placentaire', '?x')],
    [[('a-des-poils', '?x'), ('a-des-bébés-formes', '?x'), 
      ('température-stable', '?x')],
     ('placentaire-1', '?x')],
    [[('a-des-poils', '?x'), ('a-des-bébés-foetaux', '?x'), 
      ('température-stable', '?x')],
     ('marsupial', '?x')],
    [[('pond-des-oeufs', '?x'), ('a-des-poils', '?x'), 
      ('température-stable', '?x')],
     ('monotrème', '?x')],
    [[('singe', '?x')], ('genre-placentaire', '?x')],
    [[('primate', '?x')], ('singe', '?x')],
    [[('lemurien', '?x')], ('singe', '?x')],
    [[('chimpanzé', '?x')], ('primate', '?x')],
    [[('gorille', '?x')], ('primate', '?x')],
    [[('canidé', '?x')], ('genre-placentaire', '?x')],
    [[('chien', '?x')], ('canidé', '?x')],
    [[('loup', '?x')], ('canidé', '?x')],
    [[('lycaon', '?x')], ('canidé', '?x')],
    [[('félin', '?x')], ('genre-placentaire', '?x')],
    [[('chat', '?x')], ('félin', '?x')],
    [[('lion', '?x')], ('félin', '?x')],
    [[('tigre', '?x')], ('félin', '?x')],
    [[('tigre-du-bengale', '?x')], ('tigre', '?x')],
    [[('tigre-de-l-himalaya', '?x')], ('tigre', '?x')],
]

questions = [
    ('placentaire', '?quel-animal'),
    ('félin', '?quel-animal'),
    ('félin', 'mistigri'),
    ('mammifère', 'ornythorinque'),
    ('félin', 'ornythorinque'),
]

bc = BaseConnaissances(lambda descr: RegleAvecVariables(descr[0], descr[1]))
bc.ajoute_faits(faits)
bc.ajoute_regles(regles)

moteur = ChainageArriere(bc, Unificateur())

for question in questions:

    print()
    print('Question: ' + str(question))

    moteur.reinitialise()
    moteur.chaine(question)

    moteur.affiche_solutions()

    if len(argv) > 1 and argv[1].lower() == 'trace':
        moteur.affiche_trace()